﻿//extern alias dl6940;
//extern alias dl6950;

using System;
using System.Collections.Generic;
using System.Text;
//using ReaderB;
using System.Windows.Forms;
using System.Runtime.InteropServices;  //api
using System.Threading;

namespace race
{
    class DL6950Class
    {
        public static byte fComAdr1 = 0xff; //发令机
        public static int frmcomportindex1 = -1;

        public static byte fComAdr2 = 0xff; //成绩检测机
        public static int frmcomportindex2 = -1;

        public static string DevicesModel = "";

        public static string startTag = ""; //发令开始用的标签，检测到该标符系统开始计时
        private static int fCmdRet = 30; //所有执行指令的返回值
        private static int fOpenComIndex; //打开的串口索引号

        //private static  string fInventory_EPC; //存贮询查列表（如果读取的数据没有变化，则不进行刷新）

        private static bool reading = false;

        //DL6940****************************************************************************************************
        [DllImport("DL6940CSharp.dll", EntryPoint = "OpenNetPort")]
        private static extern int DL6940_OpenNetPort(int Port, string IPAddr, ref byte fComAdr, ref int frmcomportindex);

        [DllImport("DL6940CSharp.dll", EntryPoint = "CloseNetPort")]
        private static extern int DL6940_CloseNetPort(int frmcomportindex);

        [DllImport("DL6940CSharp.dll", EntryPoint = "GetReaderInformation")]
        private static extern int DL6940_GetReaderInformation(ref byte fComAdr, byte[] VersionInfo, ref byte ReaderType, ref byte TrType, ref byte dmaxfre, ref byte dminfre, ref byte powerdBm, ref byte ScanTime, ref byte Ant, ref byte BeepEn, ref byte OutputRep, int frmcomportindex);

        [DllImport("DL6940CSharp.dll", EntryPoint = "Inventory_G2")]
        private static extern int DL6940_Inventory_G2(ref byte ComAdr, byte MaskMem, byte[] MaskAdr, byte MaskLen, byte[] MaskData, byte MaskFlag, byte AdrTID, byte LenTID, byte TIDFlag, byte[] pEPCList, ref byte Ant, ref int Totallen, ref int CardNum, int frmComPortindex);

        [DllImport("DL6940CSharp.dll", EntryPoint = "SetAntennaMultiplexing")]
        private static extern int DL6940_SetAntennaMultiplexing(ref byte fComAdr, byte ANT, int frmcomportindex);

        //DL6950****************************************************************************************************
        [DllImport("DL6950CSharp.dll", EntryPoint = "OpenNetPort")]
        private static extern int DL6950_OpenNetPort(int Port, string IPAddr, ref byte fComAdr, ref int frmcomportindex);

        [DllImport("DL6950CSharp.dll", EntryPoint = "CloseNetPort")]
        private static extern int DL6950_CloseNetPort(int frmcomportindex);

        [DllImport("DL6950CSharp.dll", EntryPoint = "GetReaderInformation")]
        private static extern int DL6950_GetReaderInformation(ref byte fComAdr, byte[] VersionInfo, ref byte ReaderType, ref  byte TrType, ref byte dmaxfre, ref byte dminfre, ref byte powerdBm, ref byte ScanTime, ref byte Ant, ref byte BeepEn, ref byte OutputRep, ref byte CheckAnt, int frmcomportindex);

        [DllImport("DL6950CSharp.dll", EntryPoint = "Inventory_G2")]
        private static extern int DL6950_Inventory_G2(ref byte ComAdr, byte Qvalue, byte Session, byte MaskMem, byte[] MaskAdr, byte MaskLen, byte[] MaskData, byte MaskFlag, byte AdrTID, byte LenTID, byte TIDFlag, byte[] pEPCList, ref byte Ant, ref int Totallen, ref int CardNum, int frmComPortindex);

        [DllImport("DL6950CSharp.dll", EntryPoint = "SetAntennaMultiplexing")]
        private static extern int DL6950_SetAntennaMultiplexing(ref byte fComAdr, byte ANT, int frmcomportindex);

        public struct EPC_MEN
        {
            public string EPCNO;
            public DateTime time;
            public int rank;
            public int bibcount;
            public bool doYet;
            public bool scaned;
        }
        public static EPC_MEN[] EPC_List = new EPC_MEN[0];
        private static int CardNum = 0;
        private static int Totallen = 0;
        private static int EPClen, m;
        private static byte[] EPC6940 = new byte[5000];
        private static byte[] EPC6950 = new byte[50000];
        private static int CardIndex;
        private static string temps, temp;
        private static byte MaskMem = 0;
        private static byte[] MaskAdr = new byte[2];
        private static byte MaskLen = 0;
        private static byte[] MaskData = new byte[100];
        private static byte MaskFlag = 0;
        private static byte Ant = 0;
        private static string antstr = "";
        private static byte AdrTID = 0;
        private static byte LenTID = 0;
        private static byte TIDFlag = 0;
        private static string EPCList = "";
        private static string sEPC;

        private static byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }
        private static string ByteArrayToHexString(byte[] data)
        {
            StringBuilder sb = new StringBuilder(data.Length * 3);
            foreach (byte b in data)
                sb.Append(Convert.ToString(b, 16).PadLeft(2, '0'));
            return sb.ToString().ToUpper();
        }

        public static bool Connect(string IPAddr, string port, string comAdr, ref int frmcomportindex, ref byte fComAdr, string typename, bool ANT1, bool ANT2, bool ANT3, bool ANT4)
        {
            int openresult = -1;
            string message = "";
            if (typename == "") typename = "DL6940";

            openresult = OpenNet(IPAddr, port, comAdr, ref frmcomportindex, ref fComAdr, typename, ref message);
            /* if (openresult == 1) //型号不对
             {
                 typename = (typename == "DL6940" ? "DL6950" : "DL6940");
                 openresult = OpenNet(IPAddr, port, comAdr, ref frmcomportindex, ref fComAdr, typename, ref message);
             }
             */
            if (openresult == 0 || openresult == 2) //成功
            {
                if (openresult == 0) setant(frmcomportindex, fComAdr, ANT1, ANT2, ANT3, ANT4, typename);
                return true;
            }
            if (message != "") MessageBox.Show(message, "", MessageBoxButtons.OK, MessageBoxIcon.Stop);
            return false;
        }
        public static int OpenNet(string IPAddr, string port, string comAdr, ref int frmcomportindex, ref byte fComAdr, string typename, ref string message)
        {
            /*  0   连接成功返回
                1   读写器型号不对
                2   发卡与成绩检测读写器相同
                -1  参数有错或未知错误
                -2  连接错误
             */
            if (port == "" || IPAddr == "") return -1;

            if (comAdr == "") comAdr = "FF";
            fComAdr = Convert.ToByte(comAdr, 16); // $FF;
            int Port = int.Parse(port);
            int openresult = -1;
            if (typename == "DL6940")
            {
                openresult = DL6940_OpenNetPort(Port, IPAddr, ref fComAdr, ref frmcomportindex);
            }
            else
            {
                openresult = DL6950_OpenNetPort(Port, IPAddr, ref fComAdr, ref frmcomportindex);
            }
            fOpenComIndex = frmcomportindex;
            if ((openresult == 0x35) || (openresult == 0x30)) //已打开
            {
                if (frmcomportindex1 != -1)                //处理发令机与成绩检测机是同一读写器情况
                {
                    frmcomportindex = frmcomportindex1;
                    fComAdr = fComAdr1;
                }
                else if (frmcomportindex2 != -1)
                {
                    frmcomportindex = frmcomportindex2;
                    fComAdr = fComAdr2;
                }
                else
                {
                    CloseNet(ref frmcomportindex, typename);
                    message = "TCPIP error     ";
                    return -2;
                }
                return 2;
            }
            else if ((fOpenComIndex != -1) && (openresult != 0X35) && (openresult != 0X30))
            {
                if (getreaderinfo(frmcomportindex, fComAdr, typename))
                {
                    return 0;
                }
                CloseNet(ref frmcomportindex, typename); //型号不对
                return -2; //1
            }
            else if ((fOpenComIndex == -1) && (openresult == 0x30))
            {
                message = "TCPIP Communication Error     ";
                return -2;
            }
            return -1;
        }
        public static bool getreaderinfo(int frmcomportindex, byte fComAdr, string typename)
        {
            byte TrType = 0;
            byte[] VersionInfo = new byte[2];
            byte ReaderType = 0;
            byte ScanTime = 0;
            byte dmaxfre = 0;
            byte dminfre = 0;
            byte powerdBm = 0;
            byte Ant = 0;
            byte BeepEn = 0;
            byte OutputRep = 0;
            byte CheckAnt = 0;
            if (typename == "DL6940")
            {
                fCmdRet = DL6940_GetReaderInformation(ref fComAdr, VersionInfo, ref ReaderType, ref TrType, ref dmaxfre, ref dminfre, ref powerdBm, ref ScanTime, ref Ant, ref BeepEn, ref OutputRep, frmcomportindex);
                if (fCmdRet == 0)
                {
                    return (ReaderType == 0x0A);
                }
            }
            else
            {
                fCmdRet = DL6950_GetReaderInformation(ref fComAdr, VersionInfo, ref ReaderType, ref TrType, ref dmaxfre, ref dminfre, ref powerdBm, ref ScanTime, ref Ant, ref BeepEn, ref OutputRep, ref CheckAnt, frmcomportindex);
                if (fCmdRet == 0)
                {
                    return (ReaderType == 0x8A || ReaderType == 0x16);
                }
            }
            return false;
        }
        public static void setant(int frmcomportindex, byte fComAdr, bool ANT1, bool ANT2, bool ANT3, bool ANT4, string typename)
        {
            byte ANT = 0;
            if (ANT1) ANT = Convert.ToByte(ANT | 1);
            if (ANT2) ANT = Convert.ToByte(ANT | 2);
            if (ANT3) ANT = Convert.ToByte(ANT | 4);
            if (ANT4) ANT = Convert.ToByte(ANT | 8);
            if (typename == "DL6940")
            {
                fCmdRet = DL6940_SetAntennaMultiplexing(ref fComAdr, ANT, frmcomportindex);
            }
            else
            {
                fCmdRet = DL6950_SetAntennaMultiplexing(ref fComAdr, ANT, frmcomportindex);
            }
        }
        public static bool CloseNet(ref int frmcomportindex, string typename)
        {
            if (typename == "DL6940")
            {
                fCmdRet = DL6940_CloseNetPort(frmcomportindex);
            }
            else
            {
                fCmdRet = DL6950_CloseNetPort(frmcomportindex);
            }
            if (fCmdRet == 0)
            {
                frmcomportindex = -1;
                return true;
            }
            return false;
        }
        public static string Inventory(int frmcomportindex, byte fComAdr, string typename)
        {
            while (reading)
            {
                Application.DoEvents();
            }
            reading = true;
            try
            {
                AdrTID = 0;
                LenTID = 0;
                TIDFlag = 0;
                MaskFlag = 0;
                MaskAdr = HexStringToByteArray("0000");
                MaskLen = Convert.ToByte("00");
                MaskData = HexStringToByteArray("00");
                MaskMem = 1;
                if (typename == "DL6940")
                {
                    fCmdRet = DL6940_Inventory_G2(ref fComAdr, MaskMem, MaskAdr, MaskLen, MaskData, MaskFlag, AdrTID, LenTID, TIDFlag, EPC6940, ref Ant, ref Totallen, ref CardNum, frmcomportindex);
                }
                else
                {
                    fCmdRet = DL6950_Inventory_G2(ref fComAdr, 4, 0, MaskMem, MaskAdr, MaskLen, MaskData, MaskFlag, AdrTID, LenTID, TIDFlag, EPC6950, ref Ant, ref Totallen, ref CardNum, frmcomportindex);
                }
                if ((fCmdRet == 1) | (fCmdRet == 2) | (fCmdRet == 3) | (fCmdRet == 4) | (fCmdRet == 0xFB))//代表已查找结束，
                {
                    if (CardNum == 0 || Totallen == 0) return null;
                    byte[] daw = new byte[Totallen];

                    m = 0;
                    EPCList = null;
                    if (typename == "DL6940")
                    {
                        Array.Copy(EPC6940, daw, Totallen);
                        temps = ByteArrayToHexString(daw);
                        // if (fInventory_EPC == temps) return null;
                        //                    fInventory_EPC = temps;            //存贮记录
                        antstr = Convert.ToString(Ant, 2).PadLeft(4, '0');
                        for (CardIndex = 0; CardIndex < CardNum; CardIndex++)
                        {
                            EPClen = daw[m];
                            sEPC = temps.Substring(m * 2 + 2, EPClen * 2);
                            EPCList += sEPC + " ";
                            m = m + EPClen + 1;
                            if (sEPC.Length != EPClen * 2) return EPCList;
                        }
                    }
                    else
                    {
                        Array.Copy(EPC6950, daw, Totallen);
                        temps = ByteArrayToHexString(daw);
                        antstr = Convert.ToString(Ant, 2).PadLeft(4, '0');
                        for (CardIndex = 0; CardIndex < CardNum; CardIndex++)
                        {
                            EPClen = daw[m] + 1;
                            temp = temps.Substring(m * 2 + 2, EPClen * 2);
                            sEPC = temp.Substring(0, temp.Length - 2);
                            EPCList += sEPC + " ";
                            //string RSSI = Convert.ToInt32(temp.Substring(temp.Length - 2, 2), 16).ToString();
                            m = m + EPClen + 1;
                            if (sEPC.Length != (EPClen - 1) * 2) return EPCList;

                        }
                    }
                    return EPCList;
                    //*****************
                }
                return null;
            }
            finally
            {
                reading = false;
            }
        }
        //****************************************
        private static  frmconnect frm = null;
        static string ip1 = null, ip2 = null;
        static  string port1 = null, port2 = null;
        static string addr1 = "", addr2 = "";
        static  bool ANT1 = true, ANT2 = false, ANT3 = false, ANT4 = false;
        static bool ANT2_1 = true, ANT2_2 = false, ANT2_3 = false, ANT2_4 = false;
        public static bool frmclose=false ;
        private static bool connecting = false;

        private static void getreadinfo()
        {
            string tmp = database.GetFromini("setup", "DevicesModel");
            if (tmp != "") DevicesModel = tmp;

            tmp = database.GetFromini("setup", "ip1");
            if (tmp != "") ip1 = tmp;
            tmp = database.GetFromini("setup", "port1");
            if (tmp != "") port1 = tmp;
            tmp = database.GetFromini("setup", "addr1");
            if (tmp != "") addr1 = tmp;
            tmp = database.GetFromini("setup", "ANT1_1");
            if (tmp != "") ANT1 = bool.Parse(tmp);
            tmp = database.GetFromini("setup", "ANT1_2");
            if (tmp != "") ANT2 = bool.Parse(tmp);
            tmp = database.GetFromini("setup", "ANT1_3");
            if (tmp != "") ANT3 = bool.Parse(tmp);
            tmp = database.GetFromini("setup", "ANT1_4");
            if (tmp != "") ANT4 = bool.Parse(tmp);


            tmp = database.GetFromini("setup", "ip2");
            if (tmp != "") ip2 = tmp;
            tmp = database.GetFromini("setup", "port2");
            if (tmp != "") port2 = tmp;
            tmp = database.GetFromini("setup", "addr2");
            if (tmp != "") addr2 = tmp;
            tmp = database.GetFromini("setup", "ANT2_1");
            if (tmp != "") ANT2_1 = bool.Parse(tmp);
            tmp = database.GetFromini("setup", "ANT2_2");
            if (tmp != "") ANT2_2 = bool.Parse(tmp);
            tmp = database.GetFromini("setup", "ANT2_3");
            if (tmp != "") ANT2_3 = bool.Parse(tmp);
            tmp = database.GetFromini("setup", "ANT2_4");
            if (tmp != "") ANT2_4 = bool.Parse(tmp);
            tmp = database.GetFromini("setup", "startTag");
            if (tmp != "") startTag = tmp;
        }
        public static bool connect_reader()
        {
            if (connecting) return true;
            connecting = true;

            if (frmcomportindex2 != -1) return true;

            Cursor.Current = Cursors.WaitCursor;
            getreadinfo();
            if ((ip1 != null && port1 != null) || (ip2 != null && port2 != null))
            {
                Thread thread = new Thread(new ThreadStart(messageform));
                thread.Start();
                connect_thread();
            }
            connecting = false;
            Cursor.Current = Cursors.Default;
            return frmcomportindex2 != -1;
        }
        private static void messageform()
        {
            frm = new frmconnect();
            frm.reader1.Text = "IP:" + ip1;
            frm.reader2.Text = "IP:" + ip2;
            frm.Show();
            frm.Refresh();
            frmclose = false;
            while (connecting)
            {
                if (frmclose)
                {
                    frm.Visible = false;
                    frmclose = false;
                    frm.Refresh();
                }
                Thread.Sleep(100);
                Application.DoEvents();
            }
            frm.label1.Visible = frm.label2.Visible = false;
            frm.pictureBox1.Visible = frmcomportindex1 != -1;
            frm.pictureBox2.Visible = frmcomportindex2 != -1;
            frm.Refresh();
            Thread.Sleep(3000);
            frm.Close();
        }
        public static void connect_thread()
        {
            if (frmcomportindex2 != -1) return;
            try
            {
                if (frmcomportindex1 == -1)
                {
                    if (ip1 != null && port1 != null)
                    {
                        Connect(ip1, port1, addr1, ref frmcomportindex1, ref fComAdr1, DevicesModel, ANT1, ANT2, ANT3, ANT4);
                    }
                }
                if (ip2 != null && port2 != null)
                {
                    Connect(ip2, port2, addr2, ref frmcomportindex2, ref fComAdr2, DevicesModel, ANT2_1, ANT2_2, ANT2_3, ANT2_4);
                }
            }
            catch { }
        }
    }
}
