﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.Odbc;
using System.Threading;

namespace race
{
    public partial class Form3 : Form
    {
        const int _name = 0;
        const int _count = 1;
        const int _mark = 2;
        DialogResult result = DialogResult.Cancel;
        public Form3()
        {
            InitializeComponent();
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            Form4 frm = new Form4(this.Left.ToString() + "," + this.Top.ToString() + "," + this.Width + "," + this.Height.ToString());
            frm.Text = toolStripButton3.Text;
            if (frm.ShowDialog(this) == DialogResult.OK)
            {
                string  bibcount ="1";
                int runway = 0;
                if (frm.radioButton2.Checked)
                {
                    runway = 1;
                    bibcount = frm.textBox2.Text;
                }
                string[] str = { frm.textBox1.Text.Trim(),bibcount,frm.textBox3.Text };
                string sql = "insert into NameTable ([Name],[bibcount],[mark],[runway]) values ('" + str[0] + "','" + str[1] + "','" + str[2] + "',"+ runway + ")";
                if (database.ExecuteNonQuery(sql))
                {
                    grid1.Rows.Add(str);
                }
                result = DialogResult.OK;
            }
        }

        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            grid1.Rows.Clear();
            string sql = "select * from NameTable order by Name";
            OdbcDataReader rs = database.Datareader(sql);
            if (rs != null)
            {
                while (rs.Read())
                {
                    string[] str = { rs["Name"].ToString(), rs["bibcount"].ToString(), rs["mark"].ToString() };
                    grid1.Rows.Add(str);
                    grid1[0, grid1.Rows.Count - 1].Tag = rs["id"].ToString();
                }
                rs.Dispose();
            }
            this.Cursor = Cursors.Default;

        }

        private void Form3_Load(object sender, EventArgs e)
        {
            grid1.Columns[0].HeaderText = Properties.Settings.Default.Setting26;
            grid1.Columns[1].HeaderText = Properties.Settings.Default.Setting1;
            grid1.Columns[2].HeaderText = Properties.Settings.Default.Setting11;
        }

        private void Form3_Shown(object sender, EventArgs e)
        {
            toolStripButton4_Click(null, null);   
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            if (grid1.SelectedRows.Count == 0) return;
            if (MessageBox.Show(Properties.Settings.Default.Setting17 + "  ", "", MessageBoxButtons.YesNo, MessageBoxIcon.Question) != DialogResult.Yes) return;
            this.Cursor = Cursors.WaitCursor;
            foreach (DataGridViewRow item in grid1 .SelectedRows)
            {
                if (database.ExecuteNonQuery("delete from NameTable where [Name]='" + item.Cells[0].Value + "'"))
                {
                    grid1.Rows.Remove(item);
                    result = DialogResult.OK;
                }
            }
            this.Cursor = Cursors.Default;
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            if (grid1.SelectedRows.Count == 0) return;
            this.Cursor = Cursors.WaitCursor;
            try
            {
                Form4 frm = new Form4(this.Left.ToString() + "," + this.Top.ToString() + "," + this.Width + "," + this.Height.ToString());
                frm.Text = toolStripButton1.Text;
                string where = null;
                if (grid1.SelectedRows[0].Cells[0].Tag.ToString() != "")
                {
                    where = " [id]=" + grid1.SelectedRows[0].Cells[0].Tag.ToString();
                }
                else
                {
                    where = " [Name]='" + grid1.SelectedRows[0].Cells[0].Value + "'";
                }
                string sql = "select top 1 * from NameTable where " + where;
                OdbcDataReader rs = database.Datareader(sql);
                if (rs == null) return;
                if (rs.Read())
                {
                    this.Tag = rs["id"].ToString();
                    frm.textBox1.Text = rs["name"].ToString();
                    frm.textBox2.Text = rs["bibcount"].ToString();
                    frm.textBox3.Text = rs["mark"].ToString();
                    if (rs["runway"].ToString() == "0")
                    {
                        frm.radioButton1.Checked = true;
                    }
                    else
                    {
                        frm.radioButton2.Checked = true;
                    }
                }
                rs.Dispose();
                if (frm.ShowDialog(this) == DialogResult.OK)
                {
                    string bibcount = "1";
                    int runway = 0;
                    if (frm.radioButton2.Checked)
                    {
                        runway = 1;
                        bibcount = frm.textBox2.Text;
                    }


                    string[] str = { frm.textBox1.Text.Trim(), bibcount, frm.textBox3.Text };
                    sql = "update NameTable set [Name]='" + str[0] + "',[bibcount]='" + str[1] + "',[mark]='" + str[2] + "',[runway]=" + runway + " where [id]=" + frm.Tag.ToString();
                    if (database.ExecuteNonQuery(sql))
                    {
                        for (int col = 0; col < grid1.ColumnCount; col++)
                        {
                            grid1.Rows[grid1.CurrentRow.Index].Cells[col].Value = str[col];
                        }
                    }
                    result = DialogResult.OK;
                }
            }
            finally
            {
                this.Cursor = Cursors.Default;
            }
        }

        private void toolStripButton5_Click(object sender, EventArgs e)
        {
            this.DialogResult = result;
        }

        private void Form3_FormClosing(object sender, FormClosingEventArgs e)
        {
            while (this.Opacity > 0.1)
            {
                Application.DoEvents();
                this.Opacity -= 0.02;
                Thread.Sleep(10);
            }
        }
    }
}
