﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.Odbc;
using System.Threading;

namespace race
{
    public partial class Form4 : Form
    {
        int pHeight = 0, pleft = 0, ptop = 0, pWidth = 0, step = 20;
        double opacity = 0.02;
        public Form4(string locationandsize)
        {
            InitializeComponent();
            string[] str = locationandsize.ToString().Split(',');
            pleft = int.Parse(str[0]);
            ptop = int.Parse(str[1]);
            pWidth = int.Parse(str[2]);
            pHeight = int.Parse(str[3]);
        }
        private void button1_Click(object sender, EventArgs e)
        {
            if (textBox1.Text.Trim() == "")
            {
                textBox1.Focus();
                MessageBox.Show(Properties.Settings.Default.Setting15 + label1.Text+"   ", "", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                return;
            }
            else if (textBox2.Text.Trim() == "" && radioButton2.Checked)
            {
                textBox2.Focus();
                MessageBox.Show(Properties.Settings.Default.Setting15 + label3.Text + "   ", "", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                return;
            }
            string sql = "select id from NameTable where [Name]='" + textBox1.Text.Trim() + "'";
            if (this.Tag != null)
            {
                sql += " and [id]<>" + this.Tag.ToString();
            }
            OdbcDataReader rs = database.Datareader(sql);
            if (rs == null) return;
            if (rs.Read())
            {
                rs.Dispose();
                MessageBox.Show(Properties.Settings.Default.Setting16 + "   ", "", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                textBox1.Focus();
                return;
            }
            rs.Dispose();
            this.DialogResult = DialogResult.OK;
        }
        private void textBox2_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled=("123456789\b"+(textBox2.Text.Trim().Length>0?"0":"")).IndexOf(e.KeyChar)<0;
        }

        private void Form4_FormClosing(object sender, FormClosingEventArgs e)
        {
            while (this.Opacity > 0.1)
            {
                Application.DoEvents();
                this.Opacity -= 0.02;
                Thread.Sleep(10);
            }
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Stop();
            this.Top += (pHeight - this.Size.Height) / step;
            if ((this.Top - ptop) > (pHeight - this.Size.Height) / 2)
            {
                this.Opacity = 1;
                timer1.Enabled = false;
                return;
            }
            if (this.Opacity < 1) this.Opacity += opacity;
            timer1.Start();
        }

        private void Form4_Load(object sender, EventArgs e)
        {
            this.Location = new Point(pleft + (pWidth - this.Width) / 2, ptop);
            timer1.Enabled = true;
        }
        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            textBox2.Enabled = radioButton2.Checked;
        }
    }
}
