﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.Odbc;
using System.Threading;
namespace race
{
    public partial class Form5 : Form
    {
        const int _date = 0;
        const int _name = 1;
        const int _filename = 2;

        public Form5()
        {
            InitializeComponent();
        }
        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            grid1.Enabled = false;
            grid1.Rows.Clear();
            string sql = "select a.sid,a.date,a.filename,b.Name from (select sid,date,filename from dengjiTable group by date,sid,filename) as a  left join NameTable as b on a.sid=b.id ";
            if(date1.Checked)
            {
                sql += " where [a.date]=#" + date1.Value + "#";
            }
            sql +=" order by a.date";

            OdbcDataReader rs = database.Datareader(sql);
            if (rs != null)
            {
                while (rs.Read())
                {
                    string[] str = {DateTime.Parse (rs["date"].ToString()).ToShortDateString(),rs["Name"].ToString(), (rs["filename"].ToString()!=""?"OPEN":"")};
                    grid1.Rows.Add(str);
                    grid1[0, grid1.Rows.Count - 1].Tag = rs["sid"].ToString() + "," + rs["date"].ToString();
                    grid1[_filename, grid1.Rows.Count - 1].Tag = rs["filename"].ToString();
                }
                rs.Dispose();
            }
            grid1.Enabled = true;
            date1.Focus();
            this.Cursor = Cursors.Default;
        }

        private void Form3_Load(object sender, EventArgs e)
        {
            date1.Value = DateTime.Parse(DateTime.Now.ToShortDateString());
            splitContainer1.Panel2Collapsed = true;
            grid2.Columns[0].HeaderText = Properties.Settings.Default.Setting27; 
            grid2.Columns[1].HeaderText = Properties.Settings.Default.Setting25;
            grid2.Columns[2].HeaderText = Properties.Settings.Default.Setting26;
            grid2.Columns[3].HeaderText = Properties.Settings.Default.Setting47;
            grid2.Columns[4].HeaderText = Properties.Settings.Default.Setting48;
        }

        private void Form3_Shown(object sender, EventArgs e)
        {
            toolStripButton4_Click(null, null);
            grid1.Focus();
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            if (grid1.SelectedRows.Count == 0) return;
            if (MessageBox.Show(Properties.Settings.Default.Setting17 + "  ", "", MessageBoxButtons.YesNo, MessageBoxIcon.Question) != DialogResult.Yes) return;
            this.Cursor = Cursors.WaitCursor;
            foreach (DataGridViewRow item in grid1 .SelectedRows)
            {
                string[] str = item.Cells[0].Tag.ToString().Split(',');
                if (database.ExecuteNonQuery("delete from dengjiTable where [sid]=" + str[0] + " and [date]=#"+str[1]+"#"))
                {
                    grid1.Rows.Remove(item);
                }
            }
            this.Cursor = Cursors.Default;
        }

        private void grid1_RowEnter(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void toolStripButton5_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Form5_FormClosing(object sender, FormClosingEventArgs e)
        {
            while (this.Opacity > 0.1)
            {
                Application.DoEvents();
                this.Opacity -= 0.02;
                Thread.Sleep(10);
            }
        }

        private void grid1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            if (e.ColumnIndex == _filename)
            {
                if (grid1[e.ColumnIndex, e.RowIndex].Tag.ToString () != "")
                {
                    try
                    {
                        this.Cursor = Cursors.WaitCursor;
                        System.Diagnostics.Process.Start(grid1[e.ColumnIndex, e.RowIndex].Tag.ToString());
                    }
                    catch (Exception err)
                    {
                        MessageBox.Show(err.Message + "  ", "", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                    }
                    this.Cursor = Cursors.Default;
                }
            }
        }
    }
}
