﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace race
{
    public partial class frmreaderconnect : Form
    {
         int pHeight = 0, pleft = 0, ptop = 0, pWidth = 0, step = 20;
        double opacity = 0.02;
        public frmreaderconnect(string locationandsize)
        {
            InitializeComponent();
            string[] str = locationandsize.ToString().Split(',');
            pleft = int.Parse(str[0]);
            ptop = int.Parse(str[1]);
            pWidth = int.Parse(str[2]);
            pHeight = int.Parse(str[3]);
        }
        private void button1_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start(Application.StartupPath + "\\dl6950config.exe");
        }

        private void OpenNetPort1_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            bool result = false;
            if (OpenNetPort1.Tag.ToString() != "1")
            {
                DL6950Class.DevicesModel = comboBox1.Text;
                result = DL6950Class.Connect(ip1.Text, port1.Text, addr1.Text, ref DL6950Class.frmcomportindex1, ref DL6950Class.fComAdr1, DL6950Class.DevicesModel, ANT1_1.Checked, ANT1_2.Checked, ANT1_3.Checked, ANT1_4.Checked);
                if (result)
                {
                    panel1.Enabled = false;
                    OpenNetPort1.Text = "Disconnect";
                    OpenNetPort1.Tag = "1";
                }
            }
            else
            {
                result = DL6950Class.CloseNet(ref DL6950Class.frmcomportindex1, DL6950Class.DevicesModel);
                if (result)
                {
                    panel1.Enabled = true;
                    OpenNetPort1.Text = "connect";
                    OpenNetPort1.Tag = "0";
                   
                }
            }
            this.Cursor = Cursors.Default;
        }

        private void OpenNetPort12_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            bool result = false;
            if (OpenNetPort2.Tag.ToString() != "1")
            {
                DL6950Class.DevicesModel = comboBox1.Text;
                result = DL6950Class.Connect(ip2.Text, port2.Text, addr2.Text, ref DL6950Class.frmcomportindex2, ref DL6950Class.fComAdr2, DL6950Class.DevicesModel, ANT2_1.Checked, ANT2_2.Checked, ANT2_3.Checked, ANT2_4.Checked);
                if (result)
                {
                    panel2.Enabled = false;
                    OpenNetPort2.Text = "Disconnect";
                    OpenNetPort2.Tag = "1";
                }
            }
            else
            {
                result = DL6950Class.CloseNet(ref DL6950Class.frmcomportindex2, DL6950Class.DevicesModel);
                if (result)
                {
                    panel2.Enabled = true;
                    OpenNetPort2.Text = "connect";
                    OpenNetPort2.Tag = "0";
                }
            }
            this.Cursor = Cursors.Default;
        }
        private void button4_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        private void port1_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = "1234567890\b".IndexOf(e.KeyChar) < 0;
        }
        private void ip1_KeyPress(object sender, KeyPressEventArgs e)
        {
            ComboBox text = (ComboBox)sender;
            e.Handled = ("1234567890\b"+(text.Text .Trim().Length>0?".":"")).IndexOf(e.KeyChar) < 0;
        }

        private void addr1_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = "1234567890ABCDEFabcdef\b".IndexOf(e.KeyChar) < 0;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            database.SaveToini("setup", "ip1", ip1.Text);
            database.SaveToini("setup", "port1", port1.Text);
            database.SaveToini("setup", "addr1",addr1.Text);

            database.SaveToini("setup", "ANT1_1", ANT1_1.Checked.ToString());
            database.SaveToini("setup", "ANT1_2", ANT1_2.Checked.ToString());
            database.SaveToini("setup", "ANT1_3", ANT1_3.Checked.ToString());
            database.SaveToini("setup", "ANT1_4", ANT1_4.Checked.ToString());

            database.SaveToini("setup", "ip2", ip2.Text);
            database.SaveToini("setup", "port2", port2.Text);
            database.SaveToini("setup", "addr2", addr2.Text);

            database.SaveToini("setup", "ANT2_1", ANT2_1.Checked.ToString());
            database.SaveToini("setup", "ANT2_2", ANT2_2.Checked.ToString());
            database.SaveToini("setup", "ANT2_3", ANT2_3.Checked.ToString());
            database.SaveToini("setup", "ANT2_4", ANT2_4.Checked.ToString());

            database.SaveToini("setup", "startTag",startTag.Text);
            database.SaveToini("setup", "DevicesModel",comboBox1.Text);
            
            this.DialogResult = DialogResult.OK;
        }

        private void frmreaderconnect_Load(object sender, EventArgs e)
        {
            try
            {
                string tmp = null;
                tmp = database.GetFromini("setup", "ip1");
                if (tmp != "") ip1.Text = tmp;
                tmp = database.GetFromini("setup", "port1");
                if (tmp != "") port1.Text = tmp;
                tmp = database.GetFromini("setup", "addr1");
                if (tmp != "") addr1.Text = tmp;

                tmp = database.GetFromini("setup", "ANT1_1");
                if (tmp != "") ANT1_1.Checked = bool.Parse(tmp);
                tmp = database.GetFromini("setup", "ANT1_2");
                if (tmp != "") ANT1_2.Checked = bool.Parse(tmp);
                tmp = database.GetFromini("setup", "ANT1_3");
                if (tmp != "") ANT1_3.Checked = bool.Parse(tmp);
                tmp = database.GetFromini("setup", "ANT1_4");
                if (tmp != "") ANT1_4.Checked = bool.Parse(tmp);


                tmp = database.GetFromini("setup", "ip2");
                if (tmp != "") ip2.Text = tmp;
                tmp = database.GetFromini("setup", "port2");
                if (tmp != "") port2.Text = tmp;
                tmp = database.GetFromini("setup", "addr2");
                if (tmp != "") addr2.Text = tmp;

                tmp = database.GetFromini("setup", "ANT2_1");
                if (tmp != "") ANT2_1.Checked = bool.Parse(tmp);
                tmp = database.GetFromini("setup", "ANT2_2");
                if (tmp != "") ANT2_2.Checked = bool.Parse(tmp);
                tmp = database.GetFromini("setup", "ANT2_3");
                if (tmp != "") ANT2_3.Checked = bool.Parse(tmp);
                tmp = database.GetFromini("setup", "ANT2_4");
                if (tmp != "") ANT2_4.Checked = bool.Parse(tmp);

                tmp = database.GetFromini("setup", "startTag");
                if (tmp != "") startTag.Text = tmp;

                tmp = database.GetFromini("setup", "DevicesModel");
                if (tmp != "") comboBox1.Text = tmp;
                if (comboBox1.Text == "") comboBox1.SelectedIndex = 0;
                if (DL6950Class.frmcomportindex1 != -1)
                {
                    panel1.Enabled = false;
                    OpenNetPort1.Text = "Disconnect";
                    OpenNetPort1.Tag = "1";
                }
                if (DL6950Class.frmcomportindex2 != -1)
                {
                    panel2.Enabled = false;
                    OpenNetPort2.Text = "Disconnect";
                    OpenNetPort2.Tag = "1";
                }
            }
            catch { }

            this.Location = new Point(pleft + (pWidth - this.Width) / 2, ptop);
            timer1.Enabled = true;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {
                if (DL6950Class.connect_reader() == false) return;
                button2.Enabled = false;
                for (int i = 0; i < 20; i++)
                {
                    string EPCList = DL6950Class.Inventory(DL6950Class.frmcomportindex2, DL6950Class.fComAdr2, DL6950Class.DevicesModel);
                    if (EPCList != null)
                    {
                        string[] epc = EPCList.Split(' ');
                        startTag.Text = epc[0];
                        startTag.Focus();
                        startTag.SelectAll();
                        return;
                    }
                }
                MessageBox.Show(Properties.Settings.Default.Setting51 + "        ", "", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
            finally
            {
                button2.Enabled = true;
                this.Cursor = Cursors.Default;
            }
        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {

        }

        private void frmreaderconnect_FormClosing(object sender, FormClosingEventArgs e)
        {
            while (this.Opacity > 0.1)
            {
                Application.DoEvents();
                this.Opacity -= 0.02;
                Thread.Sleep(10);
            }

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Stop();
            this.Top += (pHeight - this.Size.Height) / step;
            if ((this.Top - ptop) > (pHeight - this.Size.Height) / 2)
            {
                this.Opacity = 1;
                timer1.Enabled = false;
                return;
            }
            if (this.Opacity < 1) this.Opacity += opacity;
            timer1.Start();
        }
    }
}
