﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.Odbc;
using System.Threading;

namespace race
{
    public partial class frmselevents : Form
    {
        int pHeight = 0, pleft = 0, ptop = 0, pWidth=0,step = 20;
        double opacity = 0.02;
        public frmselevents(string locationandsize)
        {
            InitializeComponent();
            string[] str = locationandsize.ToString().Split(',');
            pleft = int.Parse(str[0]);
            ptop = int.Parse(str[1]);
            pWidth = int.Parse(str[2]);
            pHeight = int.Parse(str[3]);
        }
        private void frmselevents_Load(object sender, EventArgs e)
        {
            this.Location = new Point(pleft + (pWidth - this.Width) / 2, ptop);
            timer1.Enabled = true;
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Stop();
            this.Top += (pHeight - this.Size.Height) / step;
            if ((this.Top - ptop) > (pHeight - this.Size.Height) / 2)
            {
                this.Opacity = 1;
                this.Tag = null;
                timer1.Enabled = false;
                refershow();
                return;

            }
            if (this.Opacity < 1) this.Opacity += opacity;

            timer1.Start();
        }
        private void frmselevents_FormClosing(object sender, FormClosingEventArgs e)
        {
            while (this.Opacity > 0.1)
            {
                Application.DoEvents();
                this.Opacity -= 0.02;
                Thread.Sleep(10);
            }
        }
        private void refershow()
        {
            this.Cursor = Cursors.WaitCursor;
            treeView1.BeginUpdate();
            treeView1.Nodes.Clear();
            string sql = "select * from NameTable order by Name";
            OdbcDataReader rs = database.Datareader(sql);
            if (rs != null)
            {
                while (rs.Read())
                {
                    treeView1.Nodes.Add(rs["id"].ToString() + "," + rs["bibcount"].ToString(), rs["Name"].ToString(), 0);

                }
                rs.Dispose();
            }
            treeView1.EndUpdate();
            treeView1.Refresh();
            treeView1.Focus();
            this.Cursor = Cursors.Default;
        }

        private void treeView1_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                this.DialogResult = DialogResult.OK;
            }
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            Form3 frm = new Form3();
            frm.Text = Properties.Settings.Default.Setting2;
            if (frm.ShowDialog(this) == DialogResult.OK)
            {
                refershow();
            }
        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            refershow();
        }
    }
}
