﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace race
{
    public partial class frmsystemname : Form
    {
         int pHeight = 0, pleft = 0, ptop = 0, pWidth = 0, step = 20;
        double opacity = 0.02;
        public frmsystemname(string locationandsize)
        {
            InitializeComponent();
            string[] str = locationandsize.ToString().Split(',');
            pleft = int.Parse(str[0]);
            ptop = int.Parse(str[1]);
            pWidth = int.Parse(str[2]);
            pHeight = int.Parse(str[3]);
        }
        private void button4_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (textBox1.Text.Trim() == "")
            {
                textBox1.Focus();
                return;
            }
            this.DialogResult = DialogResult.OK;
        }

        private void frmsystemname_FormClosing(object sender, FormClosingEventArgs e)
        {
            while (this.Opacity > 0.1)
            {
                Application.DoEvents();
                this.Opacity -= 0.02;
                Thread.Sleep(10);
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Stop();
            this.Top += (pHeight - this.Size.Height) / step;
            if ((this.Top - ptop) > (pHeight - this.Size.Height) / 2)
            {
                this.Opacity = 1;
                timer1.Enabled = false;
                return;
            }
            if (this.Opacity < 1) this.Opacity += opacity;
            timer1.Start();
        }

        private void frmsystemname_Load(object sender, EventArgs e)
        {
            this.Location = new Point(pleft + (pWidth - this.Width) / 2, ptop);
            timer1.Enabled = true;
        }
    }
}
